 //Backpropagation, binary sigmoid function network
#include <string>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <stdio.h>
#include <float.h>
#include<string.h>
using namespace std;
char person[30];
char infile[30];
char outfile[30];
double **input,
  *hidden,
  **output,
  **target,
  *bias, **weight_i_h, **weight_h_o, *errorsignal_hidden, *errorsignal_output;
int aaa = 4;
int trialn;
int input_array_size = 15,
  hidden_array_size = 100,
  output_array_size = 13,
  max_patterns,
  bias_array_size = 113,
  gaset = (unsigned long) &aaa,
  number_of_input_patterns = 0, pattern, file_loaded = 0, ytemp = 0, ztemp =
  0;
double learning_rate = 0.7, max_error_tollerance = 0.05;
char filename[128];
#define IA   16807
#define IM   2147483647
#define AM   (1.0 / IM)
#define IQ   127773
#define IR   2836
#define NTAB 32
#define NDIV (1+(IM-1) / NTAB)
#define EPS  1.2e-7
#define RNMX (1.0 - EPS)
int compare_output_to_target ();
void load_data ();
void save_data (char *argres);
void forward_pass (int pattern);
void backward_pass (int pattern);
int custom ();
int  compute_output_pattern ();
void get_file_name ();
float bedlam (long *idum);
void learn ();
void make (int no_of_patt);
void test ();
void print_data ();
void print_data_to_screen ();
void print_data_to_file ();
void output_to_screen ();
int getnumber ();
void change_learning_rate ();
void initialize_net ();
void clear_memory ();
int inn(const char * per,int no,int ch);
int check_if_file(const char * name);

int check_if_file(const char * name)
{
 ifstream in(name);
 if(!in) return -99;
in.close(); 
return 0;
}

int inn(const char * per,int no,int ch)
{
  int x, y;
int ret;
  int choice=ch;


  //cout << "\nEnter your name\n";
  //cin >> person;
strcpy (person,per);
  strcpy (infile, person);
  strcpy (outfile, person);
  strcat (infile, "in");
  strcat (outfile, "out");


  ifstream in (person);
  if (!in)
    {
      cout << "new user!!!!\n";
      ofstream out, out1;
      out.open (person);

      out1.open (infile);
      out1 << (int) 0 << "                     " << endl;

      for (x = 0; x < bias_array_size; x++)
	out << (1.0 - (2.0 * bedlam ((long *) (gaset)))) << ' ';
      out << endl << endl;
      for (x = 0; x < input_array_size; x++)
	{
	  for (y = 0; y < hidden_array_size; y++)
	    out << (1.0 - (2.0 * bedlam ((long *) (gaset)))) << ' ';
	}
      out << endl << endl;
      for (x = 0; x < hidden_array_size; x++)
	{
	  for (y = 0; y < output_array_size; y++)
	    out << (1.0 - (2.0 * bedlam ((long *) (gaset)))) << ' ';
	}
      out.close ();

    }
  in.close ();


//  if (!strcmp (argv[1], "train"))
//    choice = '1';
 // else
    //choice = '1';


  switch (choice)
    {
    case 1:


      make (no);

      load_data ();
	                                                                                                                             
	cout<<"\nLearning....";

      learn ();

      clear_memory ();
      break;
    case 2:
    cout<<"Reached traning";
      load_data ();
      ret=compute_output_pattern ();
      clear_memory ();
      break;



    };

    return ret;
}

void
initialize_net ()
{
  int x;
  input = new double *[number_of_input_patterns];
  if (!input)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  for (x = 0; x < number_of_input_patterns; x++)
    {
      input[x] = new double[input_array_size];
      if (!input[x])
	{
	  cout << endl << "memory problem!";
	  exit (1);
	}
    }
  hidden = new double[hidden_array_size];
  if (!hidden)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  output = new double *[number_of_input_patterns];
  if (!output)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  for (x = 0; x < number_of_input_patterns; x++)
    {
      output[x] = new double[output_array_size];
      if (!output[x])
	{
	  cout << endl << "memory problem!";
	  exit (1);
	}
    }
  target = new double *[number_of_input_patterns];
  if (!target)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  for (x = 0; x < number_of_input_patterns; x++)
    {
      target[x] = new double[output_array_size];
      if (!target[x])
	{
	  cout << endl << "memory problem!";
	  exit (1);
	}
    }
  bias = new double[bias_array_size];
  if (!bias)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  weight_i_h = new double *[input_array_size];
  if (!weight_i_h)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  for (x = 0; x < input_array_size; x++)
    {
      weight_i_h[x] = new double[hidden_array_size];
      if (!weight_i_h[x])
	{
	  cout << endl << "memory problem!";
	  exit (1);
	}
    }
  weight_h_o = new double *[hidden_array_size];
  if (!weight_h_o)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  for (x = 0; x < hidden_array_size; x++)
    {
      weight_h_o[x] = new double[output_array_size];
      if (!weight_h_o[x])
	{
	  cout << endl << "memory problem!";
	  exit (1);
	}
    }
  errorsignal_hidden = new double[hidden_array_size];
  if (!errorsignal_hidden)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  errorsignal_output = new double[output_array_size];
  if (!errorsignal_output)
    {
      cout << endl << "memory problem!";
      exit (1);
    }
  return;
}

void
learn ()
{
  int x, y;
  double inpx;

 // cout << "\n learning....";

  while (1)
    {
      for (y = 0; y < number_of_input_patterns; y++)
	{
	  forward_pass (y);
	  backward_pass (y);
	}
      if (compare_output_to_target ())
	{
	  cout << endl << "learning successful" << endl;
	  ofstream out;
	  out.open (person);
	  if (!out)

	    cout << "ha mem problem";


	  for (x = 0; x < bias_array_size; x++)
	    {

	      out << bias[x] << ' ';
	    }
	  out << endl << endl;
	  for (x = 0; x < input_array_size; x++)

	    for (y = 0; y < hidden_array_size; y++)
	      {
		out << weight_i_h[x][y] << ' ';
	      }

	  out << endl << endl;
	  for (x = 0; x < hidden_array_size; x++)

	    for (y = 0; y < output_array_size; y++)
	      {

		out << weight_h_o[x][y] << ' ';
	      }
	  out << endl << endl;

	  return;
	}

    }
  cout << endl << "learning not successful yet" << endl;
  return;
}

void
load_data ()
{
  int x, y;
  ifstream in, in1;


  in1.open (infile);
  in1 >> number_of_input_patterns;

  bias_array_size = hidden_array_size + output_array_size;
  initialize_net ();


  in.open (person);
  for (x = 0; x < bias_array_size; x++)
    in >> bias[x];
  for (x = 0; x < input_array_size; x++)
    {
      for (y = 0; y < hidden_array_size; y++)
	in >> weight_i_h[x][y];
    }
  for (x = 0; x < hidden_array_size; x++)
    {
      for (y = 0; y < output_array_size; y++)
	in >> weight_h_o[x][y];
    }


  in.close ();


  for (x = 0; x < number_of_input_patterns; x++)
    {
      for (y = 0; y < input_array_size; y++)
	in1 >> input[x][y];
    }
  in1.close ();

  in.open (outfile);

  for (x = 0; x < number_of_input_patterns; x++)
    {
      for (y = 0; y < output_array_size; y++)
	in >> target[x][y];
    }
  in.close ();

  return;
}


void
forward_pass (int pattern)
{

  register double temp = 0;
  register int x, y;

// INPUT -> HIDDEN
  for (y = 0; y < hidden_array_size; y++)
    {
      for (x = 0; x < input_array_size; x++)
	{
	  temp += (input[pattern][x] * weight_i_h[x][y]);
	}
      hidden[y] = (1.0 / (1.0 + exp (-1.0 * (temp + bias[y]))));
      temp = 0;
    }

// HIDDEN -> OUTPUT
  for (y = 0; y < output_array_size; y++)
    {
      for (x = 0; x < hidden_array_size; x++)
	{
	  temp += (hidden[x] * weight_h_o[x][y]);
	}
      output[pattern][y] =
	(1.0 / (1.0 + exp (-1.0 * (temp + bias[y + hidden_array_size]))));
      temp = 0;
    }
  return;
}



void
backward_pass (int pattern)
{
  register int x, y;
  register double temp = 0;

// COMPUTE ERRORSIGNAL FOR OUTPUT UNITS
  for (x = 0; x < output_array_size; x++)
    {
      errorsignal_output[x] = (target[pattern][x] - output[pattern][x]);//*output[pattern][x]*(1-output[pattern][x]);
    }

// COMPUTE ERRORSIGNAL FOR HIDDEN UNITS
  for (x = 0; x < hidden_array_size; x++)
    {
      for (y = 0; y < output_array_size; y++)
	{
	  temp += (errorsignal_output[y] * weight_h_o[x][y]);
	}
      errorsignal_hidden[x] = hidden[x] * (1 - hidden[x]) * temp;
      temp = 0.0;
    }

// ADJUST WEIGHTS OF CONNECTIONS FROM HIDDEN TO OUTPUT UNITS
  double length = 0.0;
  for (x = 0; x < hidden_array_size; x++)
    {
      length += hidden[x] * hidden[x];
    }
  if (length <= 0.1)
    length = 0.1;
  for (x = 0; x < hidden_array_size; x++)
    {
      for (y = 0; y < output_array_size; y++)
	{
	  weight_h_o[x][y] += (learning_rate * errorsignal_output[y] *
			       hidden[x] / length);
	}
    }

// ADJUST BIASES OF HIDDEN UNITS
  for (x = hidden_array_size; x < bias_array_size; x++)
    {
      bias[x] +=
	(learning_rate * errorsignal_output[x - hidden_array_size] / length);
    }

// ADJUST WEIGHTS OF CONNECTIONS FROM INPUT TO HIDDEN UNITS
  length = 0.0;
  for (x = 0; x < input_array_size; x++)
    {
      length += input[pattern][x] * input[pattern][x];
    }
  if (length <= 0.1)
    length = 0.1;
  for (x = 0; x < input_array_size; x++)
    {
      for (y = 0; y < hidden_array_size; y++)
	{
	  weight_i_h[x][y] += (learning_rate * errorsignal_hidden[y] *
			       input[pattern][x] / length);
	}
    }

// ADJUST BIASES FOR OUTPUT UNITS
  for (x = 0; x < hidden_array_size; x++)
    {
      bias[x] += (learning_rate * errorsignal_hidden[x] / length);
    }
  return;
}

int
compare_output_to_target ()
{
  register int y, z;
  register double temp, error = 0.0;
  temp = target[ytemp][ztemp] - output[ytemp][ztemp];
  if (temp < 0)
    error -= temp;
  else
    error += temp;
  if (error > max_error_tollerance)
    return 0;
  error = 0.0;
  for (y = 0; y < number_of_input_patterns; y++)
    {
      for (z = 0; z < output_array_size; z++)
	{
	  temp = target[y][z] - output[y][z];
	  if (temp < 0)
	    error -= temp;
	  else
	    error += temp;
	  if (error > max_error_tollerance)
	    {
	      ytemp = y;
	      ztemp = z;
	      return 0;
	    }
	  error = 0.0;
	}
    }
  return 1;
}

void
save_data (char *argres)
{
  int x, y;
  ofstream out;
  out.open (argres);
  if (!out)
    {
      cout << endl << "failed to save file" << endl;
      return;
    }
  out << input_array_size << endl;
  out << hidden_array_size << endl;
  out << output_array_size << endl;
  out << learning_rate << endl;
  out << number_of_input_patterns << endl << endl;
  for (x = 0; x < bias_array_size; x++)
    out << bias[x] << ' ';
  out << endl << endl;
  for (x = 0; x < input_array_size; x++)
    {
      for (y = 0; y < hidden_array_size; y++)
	out << weight_i_h[x][y] << ' ';
    }
  out << endl << endl;
  for (x = 0; x < hidden_array_size; x++)
    {
      for (y = 0; y < output_array_size; y++)
	out << weight_h_o[x][y] << ' ';
    }
  out << endl << endl;
  for (x = 0; x < number_of_input_patterns; x++)
    {
      for (y = 0; y < input_array_size; y++)
	out << input[x][y] << ' ';
      out << endl;
    }
  out << endl;
  for (x = 0; x < number_of_input_patterns; x++)
    {
      for (y = 0; y < output_array_size; y++)
	out << target[x][y] << ' ';
      out << endl;
    }
  out.close ();
  cout << endl << "data saved" << endl;
  return;
}

void
make (int no)
{
  int x, y, z;
  double inpx;


  ofstream out;
  ifstream in;



  //cout << "Enter the no.of patterns u wanna train : ";
  //cin >> z;
  z=1;







  FILE *inf = fopen (infile, "r");


  fscanf (inf, "%d", &trialn);
  fclose (inf);


  inf = fopen (infile, "r+");
  fprintf (inf, "%d", trialn + z);
  fclose (inf);


  inf = fopen (infile, "a");

  FILE *ouf = fopen (outfile, "a");

 // for (x = 0; x < z; x++)

      char ent;
 //     cout <<
//	"1.ls \n2.date \n3.pwd \n4.mail \n5.pinky \n6.dmesg \n7.who am i \n8.cal \n9.ps";
//      cout << "\nenter choice ";
      int ch=no;
 //     cin >> ch;
      //cin.get (ent);
      int i;
      for (i = 0; i < output_array_size; i++)
	{
	  if (ch - 1 == i)
	    fprintf (ouf, "%d ", 1);
	  else
	    fprintf (ouf, "%d ", 0);
	}


      fprintf (ouf, "\n\n");
      cout << "\nProcessing....\n";
//      cin.get (ent);
      system ("octave nn.m>dummy.txt");
      in.open ("data.txt");
      for (y = 0; y < input_array_size; y++)
	{
	  in >> inpx;

	  fprintf (inf, "%f ", inpx);

	}
      fprintf (inf, "\n\n");
      in.close ();



  fclose (inf);
  fclose (ouf);






  return;
}

float
bedlam (long *idum)
{
  int xj;
  long xk;
  static long iy = 0;
  static long iv[NTAB];
  float temp;

  if (*idum <= 0 || !iy)
    {
      if (-(*idum) < 1)
	{
	  *idum = 1 + *idum;
	}
      else
	{
	  *idum = -(*idum);
	}
      for (xj = NTAB + 7; xj >= 0; xj--)
	{
	  xk = (*idum) / IQ;
	  *idum = IA * (*idum - xk * IQ) - IR * xk;
	  if (*idum < 0)
	    {
	      *idum += IM;
	    }
	  if (xj < NTAB)
	    {
	      iv[xj] = *idum;
	    }
	}
      iy = iv[0];
    }

  xk = (*idum) / IQ;
  *idum = IA * (*idum - xk * IQ) - IR * xk;
  if (*idum < 0)
    {
      *idum += IM;
    }
  xj = iy / NDIV;
  iy = iv[xj];
  iv[xj] = *idum;

  if ((temp = AM * iy) > RNMX)
    {
      return (RNMX);
    }
  else
    {
      return (temp);
    }
}

void
test ()
{
  pattern = 0;
  while (pattern == 0)
    {
      cout << endl << endl << "There are " << number_of_input_patterns
	<< " input patterns in the file," << endl <<
	"enter a number within this range: ";
      pattern = getnumber ();
    }
  pattern--;
  forward_pass (pattern);
  output_to_screen ();
  return;
}

void
output_to_screen ()
{
  int x;
  // cout << endl << "Output pattern:" << endl;
  for (x = 0; x < output_array_size; x++)
    {
      cout << endl << (x + 1) << ": " << output[pattern][x] << "    binary: ";
      if (output[pattern][x] >= 0.9)
	cout << "1";
      else if (output[pattern][x] <= 0.1)
	cout << "0";
      else
	cout << "intermediate value";
    }
  cout << endl;
  return;
}

int
getnumber ()
{
  int a, b = 0;
  char c, d[5];
  while (b < 4)
    {
      do
	{
	  c = getchar ();
	}
      while (c != '1' && c != '2' && c != '3' && c != '4' && c != '5'
	     && c != '6' && c != '7' && c != '8' && c != '9' && c != '0'
	     && toascii (c) != 13);
      if (toascii (c) == 13)
	break;
      if (toascii (c) == 27)
	return 0;
      d[b] = c;
      cout << c;
      b++;
    }
  d[b] = '\0';
  a = atoi (d);
  if (a < 0 || a > number_of_input_patterns)
    a = 0;
  return a;
}

int
compute_output_pattern ()
{






  return custom ();



}

int
custom ()
{

  char filename[128];
  register double temp = 0;
  register int x, y;
  double *custom_input = new double[input_array_size];
  if (!custom_input)
    {
      cout << endl << "memory problem!";
      return 0;
    }
  double *custom_output = new double[output_array_size];
  if (!custom_output)
    {
      delete[]custom_input;
      cout << endl << "memory problem!";
      return 0;
    }

 //har ent;
 //in.get (ent);
 //or (;;)
   //
     //out << "press enter and speak";
    //cin.get (ent);
      cout << endl;

      system ("octave nn.m>dummy.txt");
      ifstream in ("data.txt");
      temp = 0;
      if (!in)
	{
	  cout << endl << "failed to load data file" << endl;
	  return 0;
	}
      for (x = 0; x < input_array_size; x++)
	{
	  in >> custom_input[x];
	}
      for (y = 0; y < hidden_array_size; y++)
	{
	  for (x = 0; x < input_array_size; x++)
	    {
	      //cout<<"wt="<<weight_i_h[x][y]<<endl;
	      temp += (custom_input[x] * weight_i_h[x][y]);
	    }
	  hidden[y] = (1.0 / (1.0 + exp (-1.0 * (temp + bias[y]))));
	  temp = 0;
	}
      for (y = 0; y < output_array_size; y++)
	{
	  for (x = 0; x < hidden_array_size; x++)
	    {
	      temp += (hidden[x] * weight_h_o[x][y]);
	    }
	  custom_output[y] =
	    (1.0 / (1.0 + exp (-1.0 * (temp + bias[y + hidden_array_size]))));
	  temp = 0;
	}

      int lett;
      double max = 0;


      for (x = 0; x < output_array_size; x++)
	{


	  if (custom_output[x] > max)
	    {
	      max = custom_output[x];
	      lett = x;
	    }




	}


/*      switch (lett)
	{
	case 0:
	  cout << endl << "ls" << endl;
	  system ("ls");
	  break;
	case 1:
	  cout << endl << "date" << endl;
	  system ("date");
	  break;
	case 2:
	  cout << endl << "pwd" << endl;
	  system ("pwd");
	  break;
	case 3:
	  cout << endl << "mail" << endl;
	  system ("mail");
	  break;
	case 4:
	  cout << endl << "pinky" << endl;
	  system ("pinky");
	  break;
	case 5:
	  cout << endl << "dmesg" << endl;
	  system ("dmesg");
	  break;
	case 6:
	  cout << endl << "who am i" << endl;
	  system ("who am i");
	  break;
	case 7:
	  cout << endl << "ls" << endl;
	  system ("ls");
	  break;
	case 8:
	  cout << endl << "cal" << endl;
	  system ("cal");
	  break;
	case 9:
	  cout << endl << "ps" << endl;
	  system ("ps");
	  break;

	}
*/

      in.close ();
      cout << endl;
 // }
  delete[]custom_input;
  delete[]custom_output;
  return lett;
}

void
clear_memory ()
{
  int x;
  for (x = 0; x < number_of_input_patterns; x++)
    {
      delete[]input[x];
    }
  delete[]input;
  delete[]hidden;
  for (x = 0; x < number_of_input_patterns; x++)
    {
      delete[]output[x];
    }
  delete[]output;
  for (x = 0; x < number_of_input_patterns; x++)
    {
      delete[]target[x];
    }
  delete[]target;
  delete[]bias;
  for (x = 0; x < input_array_size; x++)
    {
      delete[]weight_i_h[x];
    }
  delete[]weight_i_h;
  for (x = 0; x < hidden_array_size; x++)
    {
      delete[]weight_h_o[x];
    }
  delete[]weight_h_o;
  delete[]errorsignal_hidden;
  delete[]errorsignal_output;
  file_loaded = 0;
  return;
}
